diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets2.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets2.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets2.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets2.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 68,73 ****
--- 68,74 ----
  
  	public boolean notFull(Packet p) throws RtStpsException {
  
+ 		System.out.println("ATMS not full");
  		// collect time info
  		if (p.isFirstPacketInSequence() || p.isStandalonePacket()) {
  			calcTimeSpanInSeconds(p);
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets3.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets3.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets3.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets3.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 2,194 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
  /**
!  * Build the RawApplicationPackets (or read a pre-existing one) for the HDF for ATMS.
!  * This version uses the scan start bit to collect scan lines to make granules of 32 secs
!  * worth approximately.
   * 
-  * Current 
-  *
   */
  public class ATMSRawApplicationPackets3 extends RawApplicationPackets {
- 	
- 	private final int scansPerGranule = 12; // approx 32 secs worth
- 	//private final int sciPacketsPerScan = 104;
  
  
  	private Stats stats = null;
  
! 	private int scanCount = -1;  // FIXME there was a bug in VIIRS module and this should be zero and check below should >= I think...
! 	
! 	
! 	//private boolean scanCheck = false;
! 	
  	private int sciPacketCount = 0;
  
  	/**
! 	 * Constructor for creating an nth instance of a ATMS raw application data packet area builder.
! 	 * @param satellite  the name of the spacecraft as a SpacecraftId
! 	 * @param setNum  the set number
! 	 * @param scansPerGranule the number of sensor scans per granule
  	 */
! 	public ATMSRawApplicationPackets3(SpacecraftId satellite, int setNum, int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.ATMS_Science, setNum, packetPool);
! 		
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  	}
- 	
  
! 	public ATMSRawApplicationPackets3(Stats stats, SpacecraftId satellite, int setNum, int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.ATMS_Science, setNum, packetPool);
! 		
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  		this.stats = stats;
  	}
! 	
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that pre-exists.
! 	 * The contents of the dataspace are read into a memory buffer... assuming it will fit.
! 	 * @param allRDRId  the rdrAll Groups id
! 	 * @param setNum the set number of raw entry
! 	 * @throws RtStpsException Wraps any HDF exception
  	 */
! 	public ATMSRawApplicationPackets3(int allRDRId, int setNum) throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 	
! 	public ATMSRawApplicationPackets3(int readId, int setNum, boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
! 	
  
  	public boolean notFull(Packet p) throws RtStpsException {
  
! 		// when the scan start flag goes high in 528
! 		// collect packets until it flips again
! 		// when it flips, that's one scan's worth...
! 		// count the transitions, when a granules worth it collected
! 		// then its time to write them
! 		// we 
! 		
! 		if (p.isStandalonePacket() && p.hasSecondaryHeader()) {
! 			if (p.getApplicationId() == 528) {
! 				byte[] data = p.getData();
! 				int offset = 6 + 8 + 2;
! 				int scanStart = ((int)data[offset] >>> 7) & 0x00000001;
! 				if (scanStart == 1) {
  					
- 						++scanCount;
  					
  				}
  			}
  		}
! 		return (scanCount < scansPerGranule);  // true == not full, false == full
  	}
- 	
- 	
  
! 	
  
  	@Override
  	public void put(Packet p) throws RtStpsException {
! 		
! 		if (scanCount < 0) { // throw away any initial packets if we've not seen the start of a scan...
! 			if (stats == null) {
! 				//System.out.println("Trimming ATMS [" + p.getApplicationId() + "]");
! 			} else {
! 				//stats.sci_trimmedPackets.value++;
! 			}
! 			return;
! 		}
  		sciPacketCount++;
! 		
  		this.updateAppIdCounters(p.getApplicationId());
! 		
  		RDRName rdrName = RDRName.fromAppId(p.getApplicationId());
! 		
  		if (rdrName != RDRName.ATMS_Science) {
! 			throw new RtStpsException("Not a ATMS science packet [" + p.getApplicationId() + "]");
  		}
! 	
! 		
  		// collect time info
  		if (p.hasSecondaryHeader()) {
  
! 
! 			// secondary time stamp only valid in in first or standalone packets...
  			if (getFirstTime() == 0L) {
! 				//System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 			
  			setLastTime(p.getTimeStamp(8));
  		}
! 	
  		Packet pcopy = CopyPacket.deep(p, packetPool);
! 		
  		getPacketList().add(pcopy);
  
  	}
! 	
! 	
  	/**
! 	 * Write the ATMSRawApplication structure to the given HDF file specified by the HDF input handle
! 	 * @param hdfFile input handle to a previous opened HDF file
  	 * @return true if the write succeeds
! 	 * @throws RtStpsException Wraps HDF exceptions
  	 */
  	@Override
  	public boolean write(int hdfFile) throws RtStpsException {
  		boolean ret = false;
  		if (this.scanCount < this.scansPerGranule) {
  			if (stats == null) {
! 				System.out.println("Deleting partial ATMS Granule -- [" + this.scanCount + "] scans, collected packets [" + this.sciPacketCount + "]");
  			} else {
  				stats.sci_discardedGranules.value++;
! 			}	
  			ret = false;
  		} else {
  			if (stats == null) {
! 				System.out.println("Creating ATMS granule of [" + this.scanCount + "] scans");
  			} else {
  				stats.sci_createdGranules.value++;
  			}
  			super.write(hdfFile);
  			ret = true;
! 			
  		}
! 		
! 		System.out.println("ATMS Sci packets in granule: " + sciPacketCount + " Packet per scan: " + (float)sciPacketCount / (float)scansPerGranule);
! 		System.out.println("ATMS app ids = " + super.appIdCountersToString(scansPerGranule));
  		scanCount = -1;
! 		
  		sciPacketCount = 0;
  
  		return ret;
  	}
- 	
  
- 	
  	/**
! 	 * Close out the RawApplicationPacket which writes the results to the HDF file and cleans up.
  	 */
  	public void close() throws RtStpsException {
  		super.close();
! 		
  		scanCount = -1;
! 		
! 		
! 		
  		sciPacketCount = 0;
  	}
  
--- 2,303 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
  /**
!  * Build the RawApplicationPackets (or read a pre-existing one) for the HDF for
!  * ATMS. This version uses the scan start bit to collect scan lines to make
!  * granules of 32 secs worth approximately.
!  * 
!  * Current
   * 
   */
  public class ATMSRawApplicationPackets3 extends RawApplicationPackets {
  
+ 	private final int scansPerGranule = 12; // approx 32 secs worth
+ 	// private final int sciPacketsPerScan = 104;
  
  	private Stats stats = null;
  
! 	private int scanCount = -1; // FIXME there was a bug in VIIRS module and
! 								// this should be zero and check below should >=
! 								// I think...
! 
! 	// private boolean scanCheck = false;
! 
  	private int sciPacketCount = 0;
  
  	/**
! 	 * Constructor for creating an nth instance of a ATMS raw application data
! 	 * packet area builder.
! 	 * 
! 	 * @param satellite
! 	 *            the name of the spacecraft as a SpacecraftId
! 	 * @param setNum
! 	 *            the set number
! 	 * @param scansPerGranule
! 	 *            the number of sensor scans per granule
  	 */
! 	public ATMSRawApplicationPackets3(SpacecraftId satellite, int setNum,
! 			int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.ATMS_Science, setNum, packetPool);
! 
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  	}
  
! 	public ATMSRawApplicationPackets3(Stats stats, SpacecraftId satellite,
! 			int setNum, int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.ATMS_Science, setNum, packetPool);
! 
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
  		this.stats = stats;
  	}
! 
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that
! 	 * pre-exists. The contents of the dataspace are read into a memory
! 	 * buffer... assuming it will fit.
! 	 * 
! 	 * @param allRDRId
! 	 *            the rdrAll Groups id
! 	 * @param setNum
! 	 *            the set number of raw entry
! 	 * @throws RtStpsException
! 	 *             Wraps any HDF exception
  	 */
! 	public ATMSRawApplicationPackets3(int allRDRId, int setNum)
! 			throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 
! 	public ATMSRawApplicationPackets3(int readId, int setNum,
! 			boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
! 
! 	private static long firstTime = 0;
  
  	public boolean notFull(Packet p) throws RtStpsException {
+ 		// every appearance of 1289 means start of scan
+ 		boolean notFull = true;
+ 
+ 		long timestamp = p.getTimeStamp(8);
+ 
+ 		GranuleId currentGranId = new GranuleId(SpacecraftId.npp,
+ 				p.getTimeStamp(8), RDRName.ATMS_Science);
+ 
+ 		// System.out.printf("VIIRS: Gran %s seq %d ts %d obs %d \n",
+ 		// currentGranId.toString(), p.getSequenceCounter(),
+ 		// timestamp, obsTime.getMicrosSinceEpoch());
+ 
+ 		if (currentGranId.toString().startsWith("NPP-") == false) {
+ 
+ 			if (ATMSRawApplicationPackets3.firstTime < 0l) {
+ 				ATMSRawApplicationPackets3.firstTime = timestamp;
+ 				setFirstTime(timestamp);
+ 				scanCount = 0;
+ 			} else {
+ 				GranuleId startGranId = new GranuleId(SpacecraftId.npp,
+ 						getFirstTime(), RDRName.ATMS_Science);
+ 
+ 				if (startGranId.toString().contentEquals(
+ 						currentGranId.toString()) == false) {
  
! 
! 					LeapDate lpd = new LeapDate(getFirstTime());
! 					long startIET = lpd.getMicrosSinceEpoch();
! 					long startTime = GranuleId.calcGranuleStartTime(startIET,
! 							RDRName.ATMS_Science);
! 					
! 					long endTime = GranuleId.calcGranuleEndTime(startIET,
! 							RDRName.ATMS_Science);
! 
! 					
! 					
! 
! 					lpd = new LeapDate(p.getTimeStamp(8));
! 					long currentIET = lpd.getMicrosSinceEpoch();
! 	
! //					System.out.printf("ATMS: %d <= %d <= %d id %d\n", startIET,currentIET, endTime,p.getSequenceCounter() );
! 					
  					
  					
+ 					if  
+ 					(!(( startIET <= currentIET ) &&
+ 					(endTime  >=  currentIET) ))
+ 					{
+ 						System.out.println("ATMS: " + startGranId.toString()
+ 								+ " Current:" + currentGranId.toString());
+ 
+ 						System.out.printf("ATMS: %d <= %d <= %d id %d\n", startIET,currentIET, endTime,p.getSequenceCounter() );
+ 						
+ 						ATMSRawApplicationPackets3.firstTime = -1;
+ 						notFull = false; // if 20secs have gone by, the granule
+ 					}
+ 					
+ //					long stNext = GranuleId.calcGranuleStartTime(currentIET,
+ //							RDRName.ATMS_Science);
+ 
+ //					System.out.printf(
+ //							"ATMS ietthis: %d start: %d Next %d %d\n",
+ //							ietTimeThis, stThis, ietTimeNext, stNext);
+ 
+ //					if (stThis != stNext) 
+ //					{
+ //						
+ //						System.out.println("ATMS: " + startGranId.toString()
+ //								+ " Current:" + currentGranId.toString());
+ //
+ //						
+ //						ATMSRawApplicationPackets3.firstTime = -1;
+ //						notFull = false; // if 20secs have gone by, the granule
+ //					}
+ 
+ 				} else
+ 
+ 				{
+ 					scanCount++;
+ 					setLastTime(timestamp);
  				}
+ 
  			}
  		}
! 
! 		return notFull;
! 
  	}
  
! 	// public boolean notFull(Packet p) throws RtStpsException {
! 	//
! 	// // when the scan start flag goes high in 528
! 	// // collect packets until it flips again
! 	// // when it flips, that's one scan's worth...
! 	// // count the transitions, when a granules worth it collected
! 	// // then its time to write them
! 	// // we
! 	// System.out.println("ATMS not full3");
! 	//
! 	// if (p.isStandalonePacket() && p.hasSecondaryHeader()) {
! 	// if (p.getApplicationId() == 528) {
! 	// byte[] data = p.getData();
! 	// int offset = 6 + 8 + 2;
! 	// int scanStart = ((int)data[offset] >>> 7) & 0x00000001;
! 	// if (scanStart == 1) {
! 	//
! 	// ++scanCount;
! 	//
! 	// }
! 	// }
! 	// }
! 	// return (scanCount < scansPerGranule); // true == not full, false == full
! 	// }
  
  	@Override
  	public void put(Packet p) throws RtStpsException {
! 
! 		// if (scanCount < 0) { // throw away any initial packets if we've not
! 		// seen the start of a scan...
! 		// if (stats == null) {
! 		// //System.out.println("Trimming ATMS [" + p.getApplicationId() + "]");
! 		// } else {
! 		// //stats.sci_trimmedPackets.value++;
! 		// }
! 		// return;
! 		// }
  		sciPacketCount++;
! 
  		this.updateAppIdCounters(p.getApplicationId());
! 
  		RDRName rdrName = RDRName.fromAppId(p.getApplicationId());
! 
  		if (rdrName != RDRName.ATMS_Science) {
! 			throw new RtStpsException("Not a ATMS science packet ["
! 					+ p.getApplicationId() + "]");
  		}
! 
  		// collect time info
  		if (p.hasSecondaryHeader()) {
  
! 			// secondary time stamp only valid in in first or standalone
! 			// packets...
  			if (getFirstTime() == 0L) {
! 				// System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 
  			setLastTime(p.getTimeStamp(8));
  		}
! 
! 		// System.out.println("CRIS Add packet");
  		Packet pcopy = CopyPacket.deep(p, packetPool);
! 
  		getPacketList().add(pcopy);
  
  	}
! 
  	/**
! 	 * Write the ATMSRawApplication structure to the given HDF file specified by
! 	 * the HDF input handle
! 	 * 
! 	 * @param hdfFile
! 	 *            input handle to a previous opened HDF file
  	 * @return true if the write succeeds
! 	 * @throws RtStpsException
! 	 *             Wraps HDF exceptions
  	 */
  	@Override
  	public boolean write(int hdfFile) throws RtStpsException {
  		boolean ret = false;
  		if (this.scanCount < this.scansPerGranule) {
  			if (stats == null) {
! 				System.out.println("Deleting partial ATMS Granule -- ["
! 						+ this.scanCount + "] scans, collected packets ["
! 						+ this.sciPacketCount + "]");
  			} else {
  				stats.sci_discardedGranules.value++;
! 			}
  			ret = false;
  		} else {
  			if (stats == null) {
! 				System.out.println("Creating ATMS granule of ["
! 						+ this.scanCount + "] scans");
  			} else {
  				stats.sci_createdGranules.value++;
  			}
  			super.write(hdfFile);
  			ret = true;
! 
  		}
! 
! 		System.out.println("ATMS Sci packets in granule: " + sciPacketCount
! 				+ " Packet per scan: " + (float) sciPacketCount
! 				/ (float) scansPerGranule);
! 		System.out.println("ATMS app ids = "
! 				+ super.appIdCountersToString(scansPerGranule));
  		scanCount = -1;
! 
  		sciPacketCount = 0;
  
  		return ret;
  	}
  
  	/**
! 	 * Close out the RawApplicationPacket which writes the results to the HDF
! 	 * file and cleans up.
  	 */
  	public void close() throws RtStpsException {
  		super.close();
! 
  		scanCount = -1;
! 
  		sciPacketCount = 0;
  	}
  
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/ATMSRawApplicationPackets.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 83,88 ****
--- 83,89 ----
  	 * @throws RtStpsException Wraps any HDF exception
  	 */
  	public boolean notFull(Packet p) throws RtStpsException {
+ 		System.out.println("ATMS not full1");
  
  		if (scanState == ATMSScanState.Complete) {
  			return false;  // FULL
